#include "StdAfx.h"
#include "UserImageActor.h"
#include "CommonFunction.h"
#include "NPVPhotoCalcRect.h"
#include <UrlMon.h>
#pragma comment(lib,"urlmon.lib")

//profile window image size is the largest display image size(just for now)
#define MAX_PROFILE_IMAGE_WIDTH             50
#define MAX_PROFILE_IMAGE_HEIGHT            50

//request profile interval must large than 15 minutes
#define MIN_REQUEST_PROFILE_INTERVAL        (DWORD)(15*60*1000)

CUserImageActor::CUserImageActor(void)
: m_UserImageHander(this)
{
    DeleteOldProfileImage();
	g_pMessengerActor->RegisterObserver(this);
}

CUserImageActor::~CUserImageActor(void)
{
	g_pMessengerActor->UnRegisterObserver(this);
    DeleteOldProfileImage();
}


/*void CUserImageActor::HandleNextUserImage()
{
	CAutoLock autoLock(&m_CSUserIdList);
	if(m_listUserId.size() > 0)
	{
		trid_t trid = 0;
		g_pMessengerActor->GetProfileImageActor()->RequestProfileImage(m_listUserId.front(), profileThumbLargeSize, 0, 0, true, &trid);
		m_listUserId.pop_front();
	}
	else
	{
		m_UserImageHander.SetRequesting(false);
	}
}*/


bool CUserImageActor::RegisterObserver( IUserImageActorObserver* pObserver )
{
	if(NULL == pObserver)
	{
		return false;
	}
	CAutoLock l(&m_CSObserver);
	m_vecObservers.push_back(pObserver);
	return true;
}

void CUserImageActor::UnRegisterObserver( IUserImageActorObserver* pObserver )
{
	if (pObserver)
	{
		CAutoLock l(&m_CSObserver);
		vector<IUserImageActorObserver*>::iterator it = 
			std::find(m_vecObservers.begin(), m_vecObservers.end(), pObserver);
		if (it != m_vecObservers.end())
		{
			m_vecObservers.erase(it);
		}
	}
}

bool CUserImageActor::IsUserImageExist(const wstring& strUserId)
{
	CString strPath = GET_APP()->GetProfileImagePath(strUserId.c_str(), FALSE, FALSE);
	if(PathFileExists(strPath))
	{
		return true;
	}

	return false;
}

void CUserImageActor::OnGetUserImageInfo(CString strUserId)
{
    CAutoLock l(&m_CSObserver);

    //vector<IUserImageActorObserver*> vecObservers;
	//{
	//	vecObservers = m_vecObservers;
	//}

	for(UINT nIndex = 0; nIndex < m_vecObservers.size(); nIndex++)
	{
		IUserImageActorObserver* pObserver = m_vecObservers[nIndex];
		if(pObserver != NULL)
		{
			pObserver->OnUserImageActor_OnResponseUserImageInfo(strUserId);
		}
	}
}

/*bool CUserImageActor::OnGTWASActor_ResponseGetEmployeeInfo( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID )
{

	const NE_MEMBER_DATA &sMemberInfo = list.pList[0];
	if(list.nSize == 0)
	{
		return false;
	}

	if (!sMemberInfo.strPhotoURL.empty())
	{
		USERIMAGEINFO UserImageInfo;
		UserImageInfo.strUserId = sMemberInfo.strUserId.c_str();
		UserImageInfo.strUserImageURL = sMemberInfo.strPhotoURL.c_str();
		m_UserImageHander.AddRequest(UserImageInfo);
		m_UserImageHander.NotifyHandler();
	}
	else
	{
		HandleNextUserImage();
	}

	return true;
}*/

BOOL CUserImageActor::_CheckNeedRequestImage(const CString& strUserId)
{
    BOOL bWillRequest = FALSE;
    DWORD nCurTickCount = GetTickCount();

    CAutoLock locker(&m_CSUserIdList);
    RequestInfoContainer::iterator iter = m_requestInfos.find(strUserId);
    if (iter != m_requestInfos.end())
    {
        UserImageRequstInfo& requestInfo = iter->second;
        if ((requestInfo.nLastRequestTime + MIN_REQUEST_PROFILE_INTERVAL) <= nCurTickCount
            || requestInfo.nLastRequestTime > nCurTickCount)  //overflow
        {
            bWillRequest = TRUE;
            requestInfo.nLastRequestTime = nCurTickCount;
        }
    }
    else
    {
        bWillRequest = TRUE;
        UserImageRequstInfo tmpRequestInfo;
        tmpRequestInfo.nLastRequestTime = nCurTickCount;
        m_requestInfos.insert(std::make_pair(strUserId, tmpRequestInfo));
        //m_requestInfos[strUserId] = tmpRequestInfo;
    }

    return bWillRequest;
}

void CUserImageActor::RequestUserImages(const std::list<std::wstring>& listUserId)
{
	const wchar_t* sperator = L"|";
	std::wstring strListUserID;
    
	for(std::list<std::wstring>::const_iterator it = listUserId.begin(); it != listUserId.end(); it++)
	{
		const wstring& strUserName = *it;
		if(strUserName.empty())
		{
			continue;
		}
		const NE_MEMBER_DATA* memberData = g_pMessengerActor->GetEmployeeInfo(strUserName.c_str());
		if(memberData == NULL)
		{
			if(!strListUserID.empty())
			{
				strListUserID.append(sperator);
			}
			strListUserID.append(*it);
		}
		else
		{
            CAutoLock locer(&m_CSUserIdList);

            BOOL bWillRequest = _CheckNeedRequestImage(strUserName.c_str());
            const wstring& strUserPhotoURL = memberData->strPhotoURL;
			if(!strUserPhotoURL.empty() && bWillRequest)
			{
                USERIMAGEINFO UserImageInfo;
                UserImageInfo.strUserId = strUserName.c_str();
                UserImageInfo.strUserImageURL = strUserPhotoURL.c_str();
                m_UserImageHander.AddRequest(UserImageInfo);
                //m_UserImageHander.NotifyHandler();
			}
		}	
	}

	if(!strListUserID.empty())
	{
		g_pMessengerActor->RequestUserImageList(strListUserID.c_str());
	}
	
}

bool CUserImageActor::OnGTMessengerActor_ResponseUserImage( IGTMessengerActor *pActor, const vector<GT_USER_IMAGE_RESULT_DATA>& sData )
{
	for(int i = 0; i < sData.size(); i++)
	{
        if (_CheckNeedRequestImage(sData[i].strUserId.c_str()))
        {
            USERIMAGEINFO UserImageInfo;
            UserImageInfo.strUserId = sData[i].strUserId.c_str();
            UserImageInfo.strUserImageURL = sData[i].strUserImageURL.c_str();
            m_UserImageHander.AddRequest(UserImageInfo);
        }
	}
	//m_UserImageHander.NotifyHandler();
	return true;
}



void CUserImageActor::DeleteOldProfileImage()
{
    //TODO:
    BOOL bRet = FALSE;
    CString strPath = GET_APP()->GetAppDataDir() + _T("\\UserInfo\\");
    if (PathFileExists(strPath))
    {
        WIN32_FIND_DATA findData = { 0 };
        CString strFindTarget = strPath + _T("*.*");
        HANDLE hFind = NULL;
        API_VERIFY((hFind = FindFirstFile(strFindTarget, &findData)) != INVALID_HANDLE_VALUE);
        if (bRet)
        {
            do 
            {
                  if (0 ==(findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
                  {
                      //file
                      API_VERIFY(DeleteFile(strPath + findData.cFileName));
                  }

                  API_VERIFY_EXCEPT1(FindNextFile(hFind, &findData), ERROR_NO_MORE_FILES);
            }while(bRet);
            API_VERIFY(FindClose(hFind));
        }
    }
    m_requestInfos.clear();
}

CUserImageHandler& CUserImageActor::GetUserImageHandler()
{
	return m_UserImageHander;
}

CUserImageHandler::CUserImageHandler( CUserImageActor* pActor )
: m_WaitRequestUserImageInfo(LONG_MAX)
{
	m_pActor = pActor;
	//m_bHandling = false;
	m_hThreadHandle = INVALID_HANDLE_VALUE;
	//m_hRequestEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
    m_pWidthPhotoCalcRect = CNPVPhotoCalcRect::GetPhotoCalcRectObject(CNPVPhotoCalcRect::E_ZOOM_WIDTH_FIT, NULL);
    m_pHeightPhotoCalcRect = CNPVPhotoCalcRect::GetPhotoCalcRectObject(CNPVPhotoCalcRect::E_ZOOM_HEIGHT_FIT, NULL);

    UINT uThreadId = 0;
    m_hThreadHandle = (HANDLE)_beginthreadex(NULL, 0, DownLoadThread, this, 0, &uThreadId);
    m_bThreadWorking = true;
}

CUserImageHandler::~CUserImageHandler( void )
{
	//WaitThreadExit();
    SAFE_DELETE(m_pWidthPhotoCalcRect);
    SAFE_DELETE(m_pHeightPhotoCalcRect);
}

void CUserImageHandler::AddRequest( const USERIMAGEINFO& UserImageInfo )
{
    m_WaitRequestUserImageInfo.Append(UserImageInfo, INFINITE);

	//CAutoLock autoLock(&m_CSUserList);
	//for(std::list<USERIMAGEINFO>::iterator it = m_listUserImageInfo.begin();
	//	it != m_listUserImageInfo.end(); it++)
	//{
	//	if((*it).strUserId == UserImageInfo.strUserId)
	//	{
	//		return;
	//	}
	//}
	//m_listUserImageInfo.push_back(UserImageInfo);
}


//void CUserImageHandler::NotifyHandler()
//{
//	//SetEvent(m_hRequestEvent);
//	if(m_hThreadHandle == INVALID_HANDLE_VALUE)
//	{
//		Run();
//	}
//}

//void CUserImageHandler::Run()
//{
//}

BOOL CUserImageHandler::DownLoadUserImage( const USERIMAGEINFO& UserImageInfo, CString& strTmpFileName )
{
	WORD nPort = 0;
	DWORD dwServiceType = 0;
	CString strServer;
	CString strObject;
	CString strURL;
	if (!AfxParseURL(UserImageInfo.strUserImageURL, dwServiceType, strServer, strObject, nPort))
	{
		//Try sticking "http://" before it
		strURL = _T("http://") + strURL;
		if (!AfxParseURL(UserImageInfo.strUserImageURL, dwServiceType, strServer, strObject, nPort))
		{
			TRACE(_T("Failed to parse the URL: %s\n"), strURL);
			return FALSE;
		}
	}

	CFile FileWriter;
	CString strFilename = GET_APP()->GetProfileImagePath(UserImageInfo.strUserId, TRUE, FALSE);
	strTmpFileName = strFilename;
	int nExtPos = strObject.ReverseFind(_T('.'));
	int nEndPos = strObject.ReverseFind(_T('?'));
	if (nExtPos != -1)
	{
		strTmpFileName += strObject.Right(strObject.GetLength() - nExtPos);
		if(nEndPos != -1)
		{
			strTmpFileName = strTmpFileName.Left(strTmpFileName.GetLength() - nEndPos);
		}
	}
	else{
		ASSERT(FALSE);
		strTmpFileName += _T(".jpg");
	}

	HRESULT hr = URLDownloadToFile(0, UserImageInfo.strUserImageURL,
		strTmpFileName, 0, NULL);

	if(S_OK == hr)
	{
		return TRUE;
	}

	return FALSE;
}

UINT _stdcall CUserImageHandler::DownLoadThread( LPVOID lpParam )
{
	CUserImageHandler* pThis = (CUserImageHandler*)lpParam;
	return pThis->_InnerDownLoadThreadProc();
}

UINT CUserImageHandler::_InnerDownLoadThreadProc()
{
    USERIMAGEINFO userImageInfo;
	GT_MY_USER_DATA myUserData;

	if(g_pMessengerActor == NULL)
	{
		return 0;
	}

	g_pMessengerActor->GetMyUserInfo(myUserData);

    while(m_bThreadWorking)
    {
        FTLThreadWaitType waitType = m_WaitRequestUserImageInfo.Remove(userImageInfo, INFINITE);
        if (waitType != ftwtContinue)
        {
            //stop or error
            break;
        }
        FTLTRACE(TEXT("DownloadUserImage for:%s\n"), userImageInfo.strUserId);

		BOOL bSuccess = FALSE;
        CString strTmpFileName;
		if (GET_CONFIG()->EnableFunction(_T("UI_02")) || userImageInfo.strUserId == myUserData.strUserID)
		{
			bSuccess = DownLoadUserImage(userImageInfo, strTmpFileName);
		}
        //BOOL bSuccess = DownLoadUserImage(userImageInfo, strTmpFileName);
        if (!m_bThreadWorking)
        {
            //check for user stop
            DeleteFile(strTmpFileName);
            break;
        }
        if(bSuccess)
        {
            CString strFilename = GET_APP()->GetProfileImagePath(userImageInfo.strUserId, TRUE, FALSE);
            if(ScaleAndCropUserImage(userImageInfo.strUserId, strTmpFileName, strFilename))
            {
                OnSingleHandled(userImageInfo);
            }
            DeleteFile(strTmpFileName);
        }
    }

    //thread quit
    while (m_WaitRequestUserImageInfo.RemoveAfterStop(userImageInfo))
    {
        //clear all the remain wait info
    }
    return 0;
}

void CUserImageHandler::OnSingleHandled(const USERIMAGEINFO& UserImageInfo )
{
	m_pActor->OnGetUserImageInfo(UserImageInfo.strUserId);
}

BOOL CUserImageHandler::ScaleAndCropUserImage(const CString& strUserId, const CString& strSrcFileName, const CString& strDstFileName)
{
    BOOL bRet = FALSE;
    HRESULT hr = E_FAIL;
    CImage imgSrc;

    COM_VERIFY(imgSrc.Load(strSrcFileName));
    if (SUCCEEDED(hr))
    {
        CSize szImage(imgSrc.GetWidth(), imgSrc.GetHeight());
        int nMinWidthHeight = szImage.cx < szImage.cy ? szImage.cx : szImage.cy;
        if (nMinWidthHeight > MAX_PROFILE_IMAGE_WIDTH)
        {
            nMinWidthHeight = MAX_PROFILE_IMAGE_WIDTH;
        }
        CRect rcTarget(0, 0, nMinWidthHeight, nMinWidthHeight);

        CNPVPhotoCalcRect* pCalcRect = NULL;
        if (szImage.cx > szImage.cy)
        {
            pCalcRect = m_pHeightPhotoCalcRect;
        }
        else
        {
            pCalcRect = m_pWidthPhotoCalcRect;
        }
        CRect rcSacle = pCalcRect->GetPhotoRect(rcTarget, &szImage, 1.0f);
        
        CImage imgTarget;
        API_VERIFY(imgTarget.Create(nMinWidthHeight, nMinWidthHeight, 32, CImage::createAlphaChannel));
        {
            CImageDC dc(imgTarget);
            Gdiplus::Bitmap bmp((HBITMAP)imgSrc, NULL);
            Gdiplus::Graphics graphic(dc);
            //Gdiplus::RectF srcRectF(0, 0, szImage.cx, szImage.cy);
            Gdiplus::RectF dstRectF(rcSacle.left, rcSacle.top, rcSacle.Width(), rcSacle.Height());
            graphic.DrawImage(&bmp, dstRectF, 0, 0, szImage.cx, szImage.cy, Gdiplus::UnitPixel);
        }
        COM_VERIFY(imgTarget.Save(strDstFileName, Gdiplus::ImageFormatJPEG));
        bRet = SUCCEEDED(hr);
    }
    return bRet;
}

void CUserImageHandler::WaitThreadExit()
{
    BOOL bRet = FALSE;
	m_bThreadWorking = false;
    m_WaitRequestUserImageInfo.Stop();

	//API_VERIFY(SetEvent(m_hRequestEvent));
    if (m_hThreadHandle != INVALID_HANDLE_VALUE)
    {
        //thread will block URLDownloadToFile on some time
        API_VERIFY(WAIT_TIMEOUT != ::WaitForSingleObject(m_hThreadHandle, 5000));//FTL_MAX_THREAD_DEADLINE_CHECK));
        if (!bRet)
        {
            API_VERIFY(TerminateThread(m_hThreadHandle, DWORD(-1)));
        }
        API_VERIFY(CloseHandle(m_hThreadHandle));
        m_hThreadHandle = INVALID_HANDLE_VALUE;
    }
	
	//if(m_hRequestEvent != NULL)
	//{
	//	API_VERIFY(::CloseHandle(m_hRequestEvent));
    //  m_hRequestEvent = NULL;
	//}
}







